
class SetElement {
	int value;
	SetElement next;

	SetElement(int v, SetElement n) {
		value = v;
		next = n;
	}
}

class LinkedSet {

	SetElement first;

	LinkedSet() {
		first = null;
	}

	int size() {
		int result = 0;
		SetElement elem = first;
		while (elem != null) {
			result++;
			elem = elem.next;
		}
		return result;
	}

	void add(int value) {
		if (contains(value)) {
			return;
		}
		if (first == null) {
			first = new SetElement(value, null);
		} else {
			SetElement elem = first;
			while (elem.next != null) {
				elem = elem.next;
			}
			elem.next = new SetElement(value, null);
		}
	}
	
	boolean contains(int value) {
		SetElement elem = first;
		while (elem != null) {
			if (elem.value == value) {
				return true;
			}
			elem = elem.next;
		}
		return false;
	}

	void insert(int index, int value) { // without index check
		if (contains(value)) {
			return;
		}
		if (index == 0) {
			prepend(value);
		} else {
			SetElement elem = first;
			for (int i = 0; i < index - 1; i++) {
				elem = elem.next;
			}
			elem.next = new SetElement(value, elem.next);
		}
	}

	void prepend(int value) {
		first = new SetElement(value, first);
	}

	int get(int index) { // without index check
		SetElement elem = first;
		for (int i = 0; i < index; i++) {
			elem = elem.next;
		}
		return elem.value;
	}

	void remove(int value) {
		SetElement before = null;
		SetElement help = this.first;
		while (help != null) {
			if (help.value == value) {
				if (before != null) {
					before.next = help.next;
				} else { // Element == first
					this.first = help.next;
				}
			} else {
				before = help;
			}
			help = help.next;
		}
	}

	// Testprogramm
	public static void main(String[] args) {
		LinkedSet list = new LinkedSet();
		for (int i = 0; i < 10; i++) {
			list.add(i);
			list.add(i);
		}
		list.remove(5);
		list.remove(9);
		list.remove(0);
		for (int i = 10; i < 20; i++) {
			list.add(i);
		}
		list.insert(1, 77);
		for (int i = 0; i < list.size(); i++) {
			System.out.println(list.get(i));
		}
	}
}
